import { j as r } from "./index.es74.js";
import * as i from "react";
import { Slot as g } from "@radix-ui/react-slot";
import { cva as _ } from "class-variance-authority";
import { PanelLeft as k } from "lucide-react";
import { useIsMobile as C } from "./index.es75.js";
import { cn as s } from "./index.es73.js";
import { Button as I } from "./index.es8.js";
import { Input as z } from "./index.es21.js";
import { Separator as E } from "./index.es32.js";
import { Sheet as B, SheetContent as T } from "./index.es33.js";
import { Skeleton as y } from "./index.es34.js";
import { TooltipProvider as A, Tooltip as D, TooltipTrigger as O, TooltipContent as G } from "./index.es44.js";
const H = "sidebar:state", K = 60 * 60 * 24 * 7, L = "16rem", P = "18rem", $ = "3rem", V = "b", j = i.createContext(null);
function S() {
  const a = i.useContext(j);
  if (!a)
    throw new Error("useSidebar must be used within a SidebarProvider.");
  return a;
}
const W = i.forwardRef(
  ({
    defaultOpen: a = !0,
    open: e,
    onOpenChange: t,
    className: d,
    style: o,
    children: n,
    ...u
  }, m) => {
    const c = C(), [f, b] = i.useState(!1), [x, R] = i.useState(a), p = e ?? x, h = i.useCallback(
      (l) => {
        if (t)
          return t?.(
            typeof l == "function" ? l(p) : l
          );
        R(l), document.cookie = `${H}=${p}; path=/; max-age=${K}`;
      },
      [t, p]
    ), v = i.useCallback(() => c ? b((l) => !l) : h((l) => !l), [c, h, b]);
    i.useEffect(() => {
      const l = (w) => {
        w.key === V && (w.metaKey || w.ctrlKey) && (w.preventDefault(), v());
      };
      return window.addEventListener("keydown", l), () => window.removeEventListener("keydown", l);
    }, [v]);
    const N = p ? "expanded" : "collapsed", M = i.useMemo(
      () => ({
        state: N,
        open: p,
        setOpen: h,
        isMobile: c,
        openMobile: f,
        setOpenMobile: b,
        toggleSidebar: v
      }),
      [N, p, h, c, f, b, v]
    );
    return /* @__PURE__ */ r.jsx(j.Provider, { value: M, children: /* @__PURE__ */ r.jsx(A, { delayDuration: 0, children: /* @__PURE__ */ r.jsx(
      "div",
      {
        style: {
          "--sidebar-width": L,
          "--sidebar-width-icon": $,
          ...o
        },
        className: s(
          "group/sidebar-wrapper flex min-h-svh w-full has-[[data-variant=inset]]:bg-sidebar",
          d
        ),
        ref: m,
        ...u,
        children: n
      }
    ) }) });
  }
);
W.displayName = "SidebarProvider";
const q = i.forwardRef(
  ({
    side: a = "left",
    variant: e = "sidebar",
    collapsible: t = "offcanvas",
    className: d,
    children: o,
    ...n
  }, u) => {
    const { isMobile: m, state: c, openMobile: f, setOpenMobile: b } = S();
    return t === "none" ? /* @__PURE__ */ r.jsx(
      "div",
      {
        className: s(
          "flex h-full w-[--sidebar-width] flex-col bg-sidebar text-sidebar-foreground",
          d
        ),
        ref: u,
        ...n,
        children: o
      }
    ) : m ? /* @__PURE__ */ r.jsx(B, { open: f, onOpenChange: b, ...n, children: /* @__PURE__ */ r.jsx(
      T,
      {
        "data-sidebar": "sidebar",
        "data-mobile": "true",
        className: "w-[--sidebar-width] bg-sidebar p-0 text-sidebar-foreground [&>button]:hidden",
        style: {
          "--sidebar-width": P
        },
        side: a,
        children: /* @__PURE__ */ r.jsx("div", { className: "flex h-full w-full flex-col", children: o })
      }
    ) }) : /* @__PURE__ */ r.jsxs(
      "div",
      {
        ref: u,
        className: "group peer hidden md:block text-sidebar-foreground",
        "data-state": c,
        "data-collapsible": c === "collapsed" ? t : "",
        "data-variant": e,
        "data-side": a,
        children: [
          /* @__PURE__ */ r.jsx(
            "div",
            {
              className: s(
                "duration-200 relative h-svh w-[--sidebar-width] bg-transparent transition-[width] ease-linear",
                "group-data-[collapsible=offcanvas]:w-0",
                "group-data-[side=right]:rotate-180",
                e === "floating" || e === "inset" ? "group-data-[collapsible=icon]:w-[calc(var(--sidebar-width-icon)_+_theme(spacing.4))]" : "group-data-[collapsible=icon]:w-[--sidebar-width-icon]"
              )
            }
          ),
          /* @__PURE__ */ r.jsx(
            "div",
            {
              className: s(
                "duration-200 fixed inset-y-0 z-10 hidden h-svh w-[--sidebar-width] transition-[left,right,width] ease-linear md:flex",
                a === "left" ? "left-0 group-data-[collapsible=offcanvas]:left-[calc(var(--sidebar-width)*-1)]" : "right-0 group-data-[collapsible=offcanvas]:right-[calc(var(--sidebar-width)*-1)]",
                // Adjust the padding for floating and inset variants.
                e === "floating" || e === "inset" ? "p-2 group-data-[collapsible=icon]:w-[calc(var(--sidebar-width-icon)_+_theme(spacing.4)_+2px)]" : "group-data-[collapsible=icon]:w-[--sidebar-width-icon] group-data-[side=left]:border-r group-data-[side=right]:border-l",
                d
              ),
              ...n,
              children: /* @__PURE__ */ r.jsx(
                "div",
                {
                  "data-sidebar": "sidebar",
                  className: "flex h-full w-full flex-col bg-sidebar group-data-[variant=floating]:rounded-lg group-data-[variant=floating]:border group-data-[variant=floating]:border-sidebar-border group-data-[variant=floating]:shadow",
                  children: o
                }
              )
            }
          )
        ]
      }
    );
  }
);
q.displayName = "Sidebar";
const F = i.forwardRef(({ className: a, onClick: e, ...t }, d) => {
  const { toggleSidebar: o } = S();
  return /* @__PURE__ */ r.jsxs(
    I,
    {
      ref: d,
      "data-sidebar": "trigger",
      variant: "ghost",
      size: "icon",
      className: s("h-7 w-7", a),
      onClick: (n) => {
        e?.(n), o();
      },
      ...t,
      children: [
        /* @__PURE__ */ r.jsx(k, {}),
        /* @__PURE__ */ r.jsx("span", { className: "sr-only", children: "Toggle Sidebar" })
      ]
    }
  );
});
F.displayName = "SidebarTrigger";
const U = i.forwardRef(({ className: a, ...e }, t) => {
  const { toggleSidebar: d } = S();
  return /* @__PURE__ */ r.jsx(
    "button",
    {
      ref: t,
      "data-sidebar": "rail",
      "aria-label": "Toggle Sidebar",
      tabIndex: -1,
      onClick: d,
      title: "Toggle Sidebar",
      className: s(
        "absolute inset-y-0 z-20 hidden w-4 -translate-x-1/2 transition-all ease-linear after:absolute after:inset-y-0 after:left-1/2 after:w-[2px] hover:after:bg-sidebar-border group-data-[side=left]:-right-4 group-data-[side=right]:left-0 sm:flex",
        "[[data-side=left]_&]:cursor-w-resize [[data-side=right]_&]:cursor-e-resize",
        "[[data-side=left][data-state=collapsed]_&]:cursor-e-resize [[data-side=right][data-state=collapsed]_&]:cursor-w-resize",
        "group-data-[collapsible=offcanvas]:translate-x-0 group-data-[collapsible=offcanvas]:after:left-full group-data-[collapsible=offcanvas]:hover:bg-sidebar",
        "[[data-side=left][data-collapsible=offcanvas]_&]:-right-2",
        "[[data-side=right][data-collapsible=offcanvas]_&]:-left-2",
        a
      ),
      ...e
    }
  );
});
U.displayName = "SidebarRail";
const X = i.forwardRef(({ className: a, ...e }, t) => /* @__PURE__ */ r.jsx(
  "main",
  {
    ref: t,
    className: s(
      "relative flex min-h-svh flex-1 flex-col bg-background",
      "peer-data-[variant=inset]:min-h-[calc(100svh-theme(spacing.4))] md:peer-data-[variant=inset]:m-2 md:peer-data-[state=collapsed]:peer-data-[variant=inset]:ml-2 md:peer-data-[variant=inset]:ml-0 md:peer-data-[variant=inset]:rounded-xl md:peer-data-[variant=inset]:shadow",
      a
    ),
    ...e
  }
));
X.displayName = "SidebarInset";
const Y = i.forwardRef(({ className: a, ...e }, t) => /* @__PURE__ */ r.jsx(
  z,
  {
    ref: t,
    "data-sidebar": "input",
    className: s(
      "h-8 w-full bg-background shadow-none focus-visible:ring-2 focus-visible:ring-sidebar-ring",
      a
    ),
    ...e
  }
));
Y.displayName = "SidebarInput";
const J = i.forwardRef(({ className: a, ...e }, t) => /* @__PURE__ */ r.jsx(
  "div",
  {
    ref: t,
    "data-sidebar": "header",
    className: s("flex flex-col gap-2 p-2", a),
    ...e
  }
));
J.displayName = "SidebarHeader";
const Q = i.forwardRef(({ className: a, ...e }, t) => /* @__PURE__ */ r.jsx(
  "div",
  {
    ref: t,
    "data-sidebar": "footer",
    className: s("flex flex-col gap-2 p-2", a),
    ...e
  }
));
Q.displayName = "SidebarFooter";
const Z = i.forwardRef(({ className: a, ...e }, t) => /* @__PURE__ */ r.jsx(
  E,
  {
    ref: t,
    "data-sidebar": "separator",
    className: s("mx-2 w-auto bg-sidebar-border", a),
    ...e
  }
));
Z.displayName = "SidebarSeparator";
const ee = i.forwardRef(({ className: a, ...e }, t) => /* @__PURE__ */ r.jsx(
  "div",
  {
    ref: t,
    "data-sidebar": "content",
    className: s(
      "flex min-h-0 flex-1 flex-col gap-2 overflow-auto group-data-[collapsible=icon]:overflow-hidden",
      a
    ),
    ...e
  }
));
ee.displayName = "SidebarContent";
const ae = i.forwardRef(({ className: a, ...e }, t) => /* @__PURE__ */ r.jsx(
  "div",
  {
    ref: t,
    "data-sidebar": "group",
    className: s("relative flex w-full min-w-0 flex-col p-2", a),
    ...e
  }
));
ae.displayName = "SidebarGroup";
const te = i.forwardRef(({ className: a, asChild: e = !1, ...t }, d) => {
  const o = e ? g : "div";
  return /* @__PURE__ */ r.jsx(
    o,
    {
      ref: d,
      "data-sidebar": "group-label",
      className: s(
        "duration-200 flex h-8 shrink-0 items-center rounded-md px-2 text-xs font-medium text-sidebar-foreground/70 outline-none ring-sidebar-ring transition-[margin,opa] ease-linear focus-visible:ring-2 [&>svg]:size-4 [&>svg]:shrink-0",
        "group-data-[collapsible=icon]:-mt-8 group-data-[collapsible=icon]:opacity-0",
        a
      ),
      ...t
    }
  );
});
te.displayName = "SidebarGroupLabel";
const re = i.forwardRef(({ className: a, asChild: e = !1, ...t }, d) => {
  const o = e ? g : "button";
  return /* @__PURE__ */ r.jsx(
    o,
    {
      ref: d,
      "data-sidebar": "group-action",
      className: s(
        "absolute right-3 top-3.5 flex aspect-square w-5 items-center justify-center rounded-md p-0 text-sidebar-foreground outline-none ring-sidebar-ring transition-transform hover:bg-sidebar-accent hover:text-sidebar-accent-foreground focus-visible:ring-2 [&>svg]:size-4 [&>svg]:shrink-0",
        // Increases the hit area of the button on mobile.
        "after:absolute after:-inset-2 after:md:hidden",
        "group-data-[collapsible=icon]:hidden",
        a
      ),
      ...t
    }
  );
});
re.displayName = "SidebarGroupAction";
const ie = i.forwardRef(({ className: a, ...e }, t) => /* @__PURE__ */ r.jsx(
  "div",
  {
    ref: t,
    "data-sidebar": "group-content",
    className: s("w-full text-sm", a),
    ...e
  }
));
ie.displayName = "SidebarGroupContent";
const se = i.forwardRef(({ className: a, ...e }, t) => /* @__PURE__ */ r.jsx(
  "ul",
  {
    ref: t,
    "data-sidebar": "menu",
    className: s("flex w-full min-w-0 flex-col gap-1", a),
    ...e
  }
));
se.displayName = "SidebarMenu";
const oe = i.forwardRef(({ className: a, ...e }, t) => /* @__PURE__ */ r.jsx(
  "li",
  {
    ref: t,
    "data-sidebar": "menu-item",
    className: s("group/menu-item relative", a),
    ...e
  }
));
oe.displayName = "SidebarMenuItem";
const de = _(
  "peer/menu-button flex w-full items-center gap-2 overflow-hidden rounded-md p-2 text-left text-sm outline-none ring-sidebar-ring transition-[width,height,padding] hover:bg-sidebar-accent hover:text-sidebar-accent-foreground focus-visible:ring-2 active:bg-sidebar-accent active:text-sidebar-accent-foreground disabled:pointer-events-none disabled:opacity-50 group-has-[[data-sidebar=menu-action]]/menu-item:pr-8 aria-disabled:pointer-events-none aria-disabled:opacity-50 data-[active=true]:bg-sidebar-accent data-[active=true]:font-medium data-[active=true]:text-sidebar-accent-foreground data-[state=open]:hover:bg-sidebar-accent data-[state=open]:hover:text-sidebar-accent-foreground group-data-[collapsible=icon]:!size-8 group-data-[collapsible=icon]:!p-2 [&>span:last-child]:truncate [&>svg]:size-4 [&>svg]:shrink-0",
  {
    variants: {
      variant: {
        default: "hover:bg-sidebar-accent hover:text-sidebar-accent-foreground",
        outline: "bg-background shadow-[0_0_0_1px_hsl(var(--sidebar-border))] hover:bg-sidebar-accent hover:text-sidebar-accent-foreground hover:shadow-[0_0_0_1px_hsl(var(--sidebar-accent))]"
      },
      size: {
        default: "h-8 text-sm",
        sm: "h-7 text-xs",
        lg: "h-12 text-sm group-data-[collapsible=icon]:!p-0"
      }
    },
    defaultVariants: {
      variant: "default",
      size: "default"
    }
  }
), ne = i.forwardRef(
  ({
    asChild: a = !1,
    isActive: e = !1,
    variant: t = "default",
    size: d = "default",
    tooltip: o,
    className: n,
    ...u
  }, m) => {
    const c = a ? g : "button", { isMobile: f, state: b } = S(), x = /* @__PURE__ */ r.jsx(
      c,
      {
        ref: m,
        "data-sidebar": "menu-button",
        "data-size": d,
        "data-active": e,
        className: s(de({ variant: t, size: d }), n),
        ...u
      }
    );
    return o ? (typeof o == "string" && (o = {
      children: o
    }), /* @__PURE__ */ r.jsxs(D, { children: [
      /* @__PURE__ */ r.jsx(O, { asChild: !0, children: x }),
      /* @__PURE__ */ r.jsx(
        G,
        {
          side: "right",
          align: "center",
          hidden: b !== "collapsed" || f,
          ...o
        }
      )
    ] })) : x;
  }
);
ne.displayName = "SidebarMenuButton";
const le = i.forwardRef(({ className: a, asChild: e = !1, showOnHover: t = !1, ...d }, o) => {
  const n = e ? g : "button";
  return /* @__PURE__ */ r.jsx(
    n,
    {
      ref: o,
      "data-sidebar": "menu-action",
      className: s(
        "absolute right-1 top-1.5 flex aspect-square w-5 items-center justify-center rounded-md p-0 text-sidebar-foreground outline-none ring-sidebar-ring transition-transform hover:bg-sidebar-accent hover:text-sidebar-accent-foreground focus-visible:ring-2 peer-hover/menu-button:text-sidebar-accent-foreground [&>svg]:size-4 [&>svg]:shrink-0",
        // Increases the hit area of the button on mobile.
        "after:absolute after:-inset-2 after:md:hidden",
        "peer-data-[size=sm]/menu-button:top-1",
        "peer-data-[size=default]/menu-button:top-1.5",
        "peer-data-[size=lg]/menu-button:top-2.5",
        "group-data-[collapsible=icon]:hidden",
        t && "group-focus-within/menu-item:opacity-100 group-hover/menu-item:opacity-100 data-[state=open]:opacity-100 peer-data-[active=true]/menu-button:text-sidebar-accent-foreground md:opacity-0",
        a
      ),
      ...d
    }
  );
});
le.displayName = "SidebarMenuAction";
const ce = i.forwardRef(({ className: a, ...e }, t) => /* @__PURE__ */ r.jsx(
  "div",
  {
    ref: t,
    "data-sidebar": "menu-badge",
    className: s(
      "absolute right-1 flex h-5 min-w-5 items-center justify-center rounded-md px-1 text-xs font-medium tabular-nums text-sidebar-foreground select-none pointer-events-none",
      "peer-hover/menu-button:text-sidebar-accent-foreground peer-data-[active=true]/menu-button:text-sidebar-accent-foreground",
      "peer-data-[size=sm]/menu-button:top-1",
      "peer-data-[size=default]/menu-button:top-1.5",
      "peer-data-[size=lg]/menu-button:top-2.5",
      "group-data-[collapsible=icon]:hidden",
      a
    ),
    ...e
  }
));
ce.displayName = "SidebarMenuBadge";
const ue = i.forwardRef(({ className: a, showIcon: e = !1, ...t }, d) => {
  const o = i.useMemo(() => `${Math.floor(Math.random() * 40) + 50}%`, []);
  return /* @__PURE__ */ r.jsxs(
    "div",
    {
      ref: d,
      "data-sidebar": "menu-skeleton",
      className: s("rounded-md h-8 flex gap-2 px-2 items-center", a),
      ...t,
      children: [
        e && /* @__PURE__ */ r.jsx(
          y,
          {
            className: "size-4 rounded-md",
            "data-sidebar": "menu-skeleton-icon"
          }
        ),
        /* @__PURE__ */ r.jsx(
          y,
          {
            className: "h-4 flex-1 max-w-[--skeleton-width]",
            "data-sidebar": "menu-skeleton-text",
            style: {
              "--skeleton-width": o
            }
          }
        )
      ]
    }
  );
});
ue.displayName = "SidebarMenuSkeleton";
const be = i.forwardRef(({ className: a, ...e }, t) => /* @__PURE__ */ r.jsx(
  "ul",
  {
    ref: t,
    "data-sidebar": "menu-sub",
    className: s(
      "mx-3.5 flex min-w-0 translate-x-px flex-col gap-1 border-l border-sidebar-border px-2.5 py-0.5",
      "group-data-[collapsible=icon]:hidden",
      a
    ),
    ...e
  }
));
be.displayName = "SidebarMenuSub";
const fe = i.forwardRef(({ ...a }, e) => /* @__PURE__ */ r.jsx("li", { ref: e, ...a }));
fe.displayName = "SidebarMenuSubItem";
const pe = i.forwardRef(({ asChild: a = !1, size: e = "md", isActive: t, className: d, ...o }, n) => {
  const u = a ? g : "a";
  return /* @__PURE__ */ r.jsx(
    u,
    {
      ref: n,
      "data-sidebar": "menu-sub-button",
      "data-size": e,
      "data-active": t,
      className: s(
        "flex h-7 min-w-0 -translate-x-px items-center gap-2 overflow-hidden rounded-md px-2 text-sidebar-foreground outline-none ring-sidebar-ring hover:bg-sidebar-accent hover:text-sidebar-accent-foreground focus-visible:ring-2 active:bg-sidebar-accent active:text-sidebar-accent-foreground disabled:pointer-events-none disabled:opacity-50 aria-disabled:pointer-events-none aria-disabled:opacity-50 [&>span:last-child]:truncate [&>svg]:size-4 [&>svg]:shrink-0 [&>svg]:text-sidebar-accent-foreground",
        "data-[active=true]:bg-sidebar-accent data-[active=true]:text-sidebar-accent-foreground",
        e === "sm" && "text-xs",
        e === "md" && "text-sm",
        "group-data-[collapsible=icon]:hidden",
        d
      ),
      ...o
    }
  );
});
pe.displayName = "SidebarMenuSubButton";
export {
  q as Sidebar,
  ee as SidebarContent,
  Q as SidebarFooter,
  ae as SidebarGroup,
  re as SidebarGroupAction,
  ie as SidebarGroupContent,
  te as SidebarGroupLabel,
  J as SidebarHeader,
  Y as SidebarInput,
  X as SidebarInset,
  se as SidebarMenu,
  le as SidebarMenuAction,
  ce as SidebarMenuBadge,
  ne as SidebarMenuButton,
  oe as SidebarMenuItem,
  ue as SidebarMenuSkeleton,
  be as SidebarMenuSub,
  pe as SidebarMenuSubButton,
  fe as SidebarMenuSubItem,
  W as SidebarProvider,
  U as SidebarRail,
  Z as SidebarSeparator,
  F as SidebarTrigger,
  S as useSidebar
};
//# sourceMappingURL=index.es48.js.map
